/**
 * <copyright>
 * </copyright>
 *
 * $Id: Component.java 9392 2012-04-23 21:23:21Z hoenninger $
 */
package org.openxma.dsl.pom.model;

import org.eclipse.emf.common.util.EList;
import org.openxma.dsl.core.model.ConditionsBlock;
import org.openxma.dsl.core.model.IDocumentable;
import org.openxma.dsl.core.model.ModelElement;
import org.openxma.dsl.dom.model.Dependant;

import at.spardat.xma.guidesign.XMAComponent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getXmaComponent <em>Xma Component</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getStyleProperty <em>Style Property</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getDefaultPage <em>Default Page</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getDependencies <em>Dependencies</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getComponentProperties <em>Component Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getDataobjects <em>Dataobjects</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getCommands <em>Commands</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getEvents <em>Events</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getConditionsBlock <em>Conditions Block</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getPages <em>Pages</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.Component#getDefinitions <em>Definitions</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.openxma.dsl.pom.PomPackage#getComponent()
 * @model
 * @generated
 */
public interface Component extends ModelElement, ReferencedXMAGuiElement, Invokeable, IDocumentable {
	/**
	 * Returns the value of the '<em><b>Xma Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Xma Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Xma Component</em>' reference.
	 * @see #setXmaComponent(XMAComponent)
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_XmaComponent()
	 * @model
	 * @generated
	 */
	XMAComponent getXmaComponent();

	/**
	 * Sets the value of the '{@link org.openxma.dsl.pom.model.Component#getXmaComponent <em>Xma Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Xma Component</em>' reference.
	 * @see #getXmaComponent()
	 * @generated
	 */
	void setXmaComponent(XMAComponent value);

	/**
	 * Returns the value of the '<em><b>Style Property</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Style Property</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Style Property</em>' containment reference.
	 * @see #setStyleProperty(StyleProperty)
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_StyleProperty()
	 * @model containment="true"
	 * @generated
	 */
	StyleProperty getStyleProperty();

	/**
	 * Sets the value of the '{@link org.openxma.dsl.pom.model.Component#getStyleProperty <em>Style Property</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Style Property</em>' containment reference.
	 * @see #getStyleProperty()
	 * @generated
	 */
	void setStyleProperty(StyleProperty value);

	/**
	 * Returns the value of the '<em><b>Default Page</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Default Page</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Page</em>' reference.
	 * @see #setDefaultPage(XmadslPage)
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_DefaultPage()
	 * @model
	 * @generated
	 */
    XmadslPage getDefaultPage();

    /**
	 * Sets the value of the '{@link org.openxma.dsl.pom.model.Component#getDefaultPage <em>Default Page</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Page</em>' reference.
	 * @see #getDefaultPage()
	 * @generated
	 */
    void setDefaultPage(XmadslPage value);

    /**
	 * Returns the value of the '<em><b>Dependencies</b></em>' reference list.
	 * The list contents are of type {@link org.openxma.dsl.dom.model.Dependant}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependencies</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependencies</em>' reference list.
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_Dependencies()
	 * @model
	 * @generated
	 */
	EList<Dependant> getDependencies();

	/**
	 * Returns the value of the '<em><b>Component Properties</b></em>' containment reference list.
	 * The list contents are of type {@link org.openxma.dsl.pom.model.ObjectProperty}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component Properties</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component Properties</em>' containment reference list.
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_ComponentProperties()
	 * @model containment="true"
	 * @generated
	 */
	EList<ObjectProperty> getComponentProperties();

	/**
	 * Returns the value of the '<em><b>Dataobjects</b></em>' containment reference list.
	 * The list contents are of type {@link org.openxma.dsl.pom.model.DataObjectVariable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dataobjects</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dataobjects</em>' containment reference list.
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_Dataobjects()
	 * @model containment="true"
	 * @generated
	 */
	EList<DataObjectVariable> getDataobjects();

	/**
	 * Returns the value of the '<em><b>Commands</b></em>' containment reference list.
	 * The list contents are of type {@link org.openxma.dsl.pom.model.Command}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Commands</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Commands</em>' containment reference list.
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_Commands()
	 * @model containment="true"
	 * @generated
	 */
	EList<Command> getCommands();

	/**
	 * Returns the value of the '<em><b>Events</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Events</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' containment reference.
	 * @see #setEvents(EventMappingList)
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_Events()
	 * @model containment="true"
	 * @generated
	 */
	EventMappingList getEvents();

	/**
	 * Sets the value of the '{@link org.openxma.dsl.pom.model.Component#getEvents <em>Events</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Events</em>' containment reference.
	 * @see #getEvents()
	 * @generated
	 */
	void setEvents(EventMappingList value);

	/**
	 * Returns the value of the '<em><b>Conditions Block</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Conditions Block</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Conditions Block</em>' containment reference.
	 * @see #setConditionsBlock(ConditionsBlock)
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_ConditionsBlock()
	 * @model containment="true"
	 * @generated
	 */
	ConditionsBlock getConditionsBlock();

	/**
	 * Sets the value of the '{@link org.openxma.dsl.pom.model.Component#getConditionsBlock <em>Conditions Block</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Conditions Block</em>' containment reference.
	 * @see #getConditionsBlock()
	 * @generated
	 */
	void setConditionsBlock(ConditionsBlock value);

	/**
	 * Returns the value of the '<em><b>Pages</b></em>' containment reference list.
	 * The list contents are of type {@link org.openxma.dsl.pom.model.Page}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pages</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pages</em>' containment reference list.
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_Pages()
	 * @model containment="true"
	 * @generated
	 */
	EList<Page> getPages();

	/**
	 * Returns the value of the '<em><b>Definitions</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Definitions</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Definitions</em>' containment reference.
	 * @see #setDefinitions(Definitions)
	 * @see org.openxma.dsl.pom.PomPackage#getComponent_Definitions()
	 * @model containment="true"
	 * @generated
	 */
	Definitions getDefinitions();

	/**
	 * Sets the value of the '{@link org.openxma.dsl.pom.model.Component#getDefinitions <em>Definitions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Definitions</em>' containment reference.
	 * @see #getDefinitions()
	 * @generated
	 */
	void setDefinitions(Definitions value);

} // Component
