package org.openxma.dsl.pom.resource;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.resource.IEObjectDescription;
import org.eclipse.xtext.resource.impl.DefaultResourceDescriptionStrategy;
import org.eclipse.xtext.util.IAcceptor;

import at.spardat.xma.guidesign.XMAComponent;
import at.spardat.xma.guidesign.util.GuidesignSwitch;

import com.google.common.base.Predicate;

public class XmaResourceDescriptionStrategy extends DefaultResourceDescriptionStrategy {
    private static final Predicate<EObject> EXPORTED_OBJECTS_FILTER = new ExportedObjectsFilter();

    @Override
    public boolean createEObjectDescriptions(EObject eObject, IAcceptor<IEObjectDescription> acceptor) {
        return EXPORTED_OBJECTS_FILTER.apply(eObject) && 
                super.createEObjectDescriptions(eObject, acceptor);
    }

    private static class ExportedObjectsFilter extends GuidesignSwitch implements Predicate<EObject> {

        public boolean apply(EObject input) {
            return (Boolean) doSwitch(input);
        }

        @Override
        public Object defaultCase(EObject object) {
            return Boolean.FALSE;
        }

        @Override
        public Object caseXMAComponent(XMAComponent object) {
            return true;
        }

    }
}
