package org.openxma.dsl.pom.resource;

import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.resource.IResourceDescription.Manager;
import org.eclipse.xtext.resource.impl.DefaultResourceServiceProvider;
import org.eclipse.xtext.util.CancelIndicator;
import org.eclipse.xtext.validation.CheckMode;
import org.eclipse.xtext.validation.IResourceValidator;
import org.eclipse.xtext.validation.Issue;
import org.openxma.dsl.common.DslConstants;

import com.google.inject.Inject;

public class XmaResourceServiceProvider extends DefaultResourceServiceProvider {

    @Inject
    private XmaResourceDescriptionManager resourceDescriptionManager;

    public boolean canHandle(URI uri) {
        return DslConstants.OPENXMA_XMA_FILE_EXTENSION.equals(uri.fileExtension());
    }

    public IResourceValidator getResourceValidator() {
        return new IResourceValidator() {
            public List<Issue> validate(Resource resource, CheckMode mode, CancelIndicator indicator) {
                return Collections.emptyList();
            }
        };
    }

    @Override
    public Manager getResourceDescriptionManager() {
        return resourceDescriptionManager;
    }

}
